=== debian/changelog ===
deepin-terminal (5.4.28-1) unstable; urgency=medium

  * update

 -- Deepin Packages Builder <packages@deepin.org>  Mon, 17 Jan 2022 09:41:57 +0800

deepin-terminal (5.2.0) unstable; urgency=medium

  * Initial Release.

 -- Deepin Packages Builder <packages@deepin.com>  Mon, 13 Jan 2020 16:13:35 +0800
