## deepin-terminal 5.4.33

=== CMakeLists.txt ===
--- 
+++ 
@@ -49,6 +49,12 @@
 set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fstack-protector-strong -D_FORTITY_SOURCE=1 -z noexecstack -pie -fPIC -z lazy")
 
 configure_file(src/environments.h.in environments.h @ONLY)
+
+#代码覆盖率开关
+if(CMAKE_COVERAGE_ARG STREQUAL "CMAKE_COVERAGE_ARG_ON")
+  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -g -Wall -fprofile-arcs -ftest-coverage")
+  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g -Wall -fprofile-arcs -ftest-coverage")
+endif()
 
 # Find the QtWidgets library
 
@@ -118,6 +124,7 @@
 set (DTNG_CPP_FILES
     src/common/utils.cpp
     src/common/settingio.cpp
+    src/common/eventlogutils.cpp
     src/customcommand/customcommandoptdlg.cpp
     src/customcommand/customcommandpanel.cpp
     src/customcommand/customcommandplugin.cpp
@@ -168,6 +175,7 @@
     src/common/define.h
     src/common/utils.h
     src/common/settingio.h
+    src/common/eventlogutils.h
     src/customcommand/customcommandoptdlg.h
     src/customcommand/customcommandpanel.h
     src/customcommand/customcommandplugin.h
@@ -281,3 +289,5 @@
 
 # Unit Test
 add_subdirectory(tests)
+
+
