=== debian/changelog ===
deepin-terminal (5.4.33-1) unstable; urgency=medium

  * update

 -- Deepin Packages Builder <packages@deepin.org>  Fri, 12 Aug 2022 10:29:49 +0800
