## deepin-terminal 5.4.35

=== CMakeLists.txt ===
--- 
+++ 
@@ -43,7 +43,7 @@
 endif()
 
 #Use deepin-turbo for Performance optimization
-set(CMAKE_CXX_FLAGS "${CMAKE_C_FLAGS} -Wl,--as-need -fPIE")
+set(CMAKE_CXX_FLAGS "${CMAKE_C_FLAGS} -Wl,--as-needed -fPIE")
 set(CMAKE_EXE_LINKER_FLAGS "-pie")
 #安全编译参数
 set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fstack-protector-strong -D_FORTITY_SOURCE=1 -z noexecstack -pie -fPIC -z lazy")
@@ -288,6 +288,6 @@
         DESTINATION /usr/share/deepin-manual/manual-assets/application/)
 
 # Unit Test
+if (CMAKE_BUILD_TYPE MATCHES Debug)
 add_subdirectory(tests)
-
-
+endif()
