=== debian/changelog ===
deepin-terminal (5.4.35-1) unstable; urgency=medium

  * update

 -- Deepin Packages Builder <packages@deepin.org>  Wed, 14 Sep 2022 15:49:55 +0800
