## deepin-terminal 5.9.40

=== debian/changelog ===
deepin-terminal (5.9.40-1) unstable; urgency=medium

  * update

 -- Deepin Packages Builder <packages@deepin.org>  Wed, 04 Jan 2023 14:04:27 +0800

deepin-terminal (5.9.40) unstable; urgency=medium

  * New version 5.9.40

 -- hemingyang <hemingyang@uniontech.com>  Mon, 03 Jan 2023 11:23:05 +0800
