=== debian/changelog ===
deepin-terminal (5.9.40+dfsg-4build1) plucky; urgency=medium

  * No-change rebuild for lxqt-build-tools C++17 -> C++20.

 -- Simon Quigley <tsimonq2@ubuntu.com>  Fri, 03 Jan 2025 03:51:38 -0600

deepin-terminal (5.9.40+dfsg-4) unstable; urgency=medium

  * Add patch to use lxqt2-build-tools.
  * debian/control:
    + Add qt6-tools-dev to Build-Depends.
    + Tighten Build-Depends lxqt-build-tools to (>= 2.0.0~).
    + Replace Build-Depends pkg-config to pkgconf.

 -- Arun Kumar Pariyar <arun@debian.org>  Wed, 27 Nov 2024 22:17:37 +0545

deepin-terminal (5.9.40+dfsg-3) unstable; urgency=medium

  * Add qttools5-dev to Build-Deps (Closes: #1078279).

 -- Arun Kumar Pariyar <arun@debian.org>  Mon, 16 Sep 2024 00:47:32 +0545

deepin-terminal (5.9.40+dfsg-2) unstable; urgency=medium

  [ Arun Kumar Pariyar ]
  * debian/patches:
    + Add 0003-avoid-regeneration-of-ts-files.patch (Closes: #1044857).

  [ Dmitry Shachnev ]
  * Backport upstream fix to not overwrite CMAKE_CXX_FLAGS by CMAKE_C_FLAGS.
    Closes: #1066406.

 -- Arun Kumar Pariyar <arun@debian.org>  Mon, 08 Apr 2024 00:12:37 +0545

deepin-terminal (5.9.40+dfsg-1) unstable; urgency=medium

  * New upstream version 5.9.40+dfsg. (Closes: #1028611)
  * debian/patches:
    + Drop 0003-remove-definitions-DQT_NO_CAST_FROM_ASCII-DQT_NO_CAS.patch
  * Update lintian-overrides.
  * debian/control:
    + Bump Standards-Version to 4.6.2.
    + Add packages libgmock-dev, libgtest-dev, libsecret-1-dev, and
      libxcb-ewmh-dev to B-D.
    + Drop libatspi2.0-dev and chrpath from B-D.
  * debian/copyright: Refresh copyright information.
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse.

 -- Arun Kumar Pariyar <arun@debian.org>  Thu, 23 Feb 2023 17:48:17 +0545
