## deepin-terminal 5.9.51%2Bdfsg

=== debian/changelog ===
deepin-terminal (5.9.51+dfsg-1.1build3) resolute; urgency=medium

  * No-change rebuild against Qt 5.15.18 on amd64v3.

 -- Dmitry Shachnev <mitya57@ubuntu.com>  Sun, 18 Jan 2026 10:26:20 +0300

deepin-terminal (5.9.51+dfsg-1.1build2) resolute; urgency=medium

  * No-change rebuild against Qt 5.15.18.

 -- Dmitry Shachnev <mitya57@ubuntu.com>  Wed, 14 Jan 2026 20:02:00 +0300

deepin-terminal (5.9.51+dfsg-1.1build1) resolute; urgency=medium

  * No-change rebuild for icu soname.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 03 Dec 2025 14:37:44 +0100

deepin-terminal (5.9.51+dfsg-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Fix FTBFS with CMake 4. (Closes: #1112836)

 -- Adrian Bunk <bunk@debian.org>  Sat, 11 Oct 2025 18:23:53 +0300

deepin-terminal (5.9.51+dfsg-1) unstable; urgency=medium

  * New upstream release. (Closes: #1096235)
  * debian/control: Add new build-dep.
  * debian/patches/0004: Refreshed.

 -- Boyuan Yang <byang@debian.org>  Mon, 17 Feb 2025 16:43:15 -0500
