## deepin-terminal 5.9.51+dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -66,7 +66,7 @@
 find_package(Qt5LinguistTools REQUIRED)
 find_package(Qt5Network REQUIRED)
 find_package(Qt5X11Extras REQUIRED)
-#find_package(DtkWidget REQUIRED)
+find_package(DtkWidget REQUIRED)
 #find_package(DtkCore REQUIRED)
 #find_package(DtkGui REQUIRED)
 
@@ -286,6 +286,25 @@
 
 install(DIRECTORY src/assets/deepin-terminal
         DESTINATION /usr/share/deepin-manual/manual-assets/application/)
+message("CMAKE_INSTALL_PREFIX: " ${CMAKE_INSTALL_PREFIX})
+#安装日志调试模式配置文件
+install(FILES src/assets/config/debugconfig/org.deepin.terminal.json
+        DESTINATION ${CMAKE_INSTALL_PREFIX}/share/deepin-debug-config/deepin-debug-config.d/)
+#install(FILES src/assets/config/debugconfig/deepin-terminal_debug.sh
+#        DESTINATION ${CMAKE_INSTALL_PREFIX}/share/deepin-debug-config/shell/)
+#安装DConfig配置
+set(APPID org.deepin.terminal)
+set(configFile ${PROJECT_SOURCE_DIR}/src/assets/config/dconfig/org.deepin.terminal.json)
+if (DEFINED DSG_DATA_DIR)
+    message("-- DConfig is supported by DTK")
+    dconfig_meta_files(APPID ${APPID} FILES ${configFile})
+else()
+    message("-- DConfig is not supported by DTK")
+    install(FILES ${configFile} DESTINATION ${CMAKE_INSTALL_PREFIX}/share/dsg/config/org.deepin.terminal/)
+endif()
+#安装日志收集工具配置文件
+install(FILES src/assets/config/logconfig/org.deepin.terminal.json
+        DESTINATION ${CMAKE_INSTALL_PREFIX}/share/deepin-log-viewer/deepin-log.conf.d/)
 
 # Unit Test
 if (CMAKE_BUILD_TYPE MATCHES Debug)
